#include <GL/glut.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>


GLfloat light_diffuse[] = {0.5, 0.5, 0.5, 1.0};
GLfloat light_ambient[] = {0.25, 0.25, 0.25, 1.0}; 
/* GLfloat light_ambient[] = {1.0, 1.0, 1.0, 1.0}; */
GLfloat light_position[] = {-1.0, 1.0, 1.0, 0.0};

float rot1 = 0.0;

inline float myrandf()
{
/* return 0.75; */
 return ((float)rand()) / ((float)RAND_MAX);
}

void
drawBox(void)
{
 int i;
 FILE *f = fopen("test.dat", "r");
 char buf[1024], *foo;
 double v[12];

/*
  glRotatef(rand()%100-50, 1.0, 0.0, 0.0);
  glRotatef(rand()%100-50, 0.0, 0.0, 1.0);
*/

  glRotatef(2, 1.0, 0.0, 0.0);
  glRotatef(2, 0.0, 0.0, 1.0);


 while(!feof(f))
    {
     GLfloat ambient[] = {myrandf(), myrandf(), myrandf(), 1.0};
     glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT, ambient);
     glMaterialfv(GL_FRONT_AND_BACK, GL_DIFFUSE, ambient);

     fgets(buf, 1000, f);
     i=0;
     foo = strtok(buf, ", \r\n");
     while(foo != NULL)
        {
         v[i] = atof(foo);
         i++;
         foo = strtok(NULL, ", \r\n");
        }

     glBegin(GL_QUADS);
     glNormal3f(v[0], v[1], v[2]);
     glVertex3f(v[0], v[1], v[2]);
     glNormal3f(v[3], v[4], v[5]);
     glVertex3f(v[3], v[4], v[5]);
     glNormal3f(v[6], v[7], v[8]);
     glVertex3f(v[6], v[7], v[8]);
     glNormal3f(v[9], v[10], v[11]);
     glVertex3f(v[9], v[10], v[11]);
     glEnd();
    }

 fclose(f);
}


 /* glutSolidTeapot(3.0); */
 /* glutSolidTorus(1.0, 2.0, 10, 10); */
 /* glutSolidIcosahedron(); */
 /* glFrontFace(GL_CW); */
 /* glutSolidTeapot(1.0); */
 /* glFrontFace(GL_CCW); */



void
display(void)
{
  glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
  drawBox();
  glutSwapBuffers();
}

void
init(void)
{
  glLightfv(GL_LIGHT0, GL_DIFFUSE, light_diffuse);  
  glLightfv(GL_LIGHT0, GL_POSITION, light_position);  
  glLightfv(GL_LIGHT0, GL_AMBIENT, light_ambient);
  glEnable(GL_LIGHT0);

  glEnable(GL_LIGHTING);
  glEnable(GL_DEPTH_TEST);

  /* Set up the view */
  glMatrixMode(GL_PROJECTION);
  gluPerspective( 
    /* field of view in degree */ 40.0,
    /* aspect ratio */ 1.0,
    /* Z near */ 1.0, 
    /* Z far */ 30.0);
  glMatrixMode(GL_MODELVIEW);
  gluLookAt(0.0, 0.0, 3.0,  /* eye is at (0,0,5) */
            0.0, 0.0, 0.0,   /* center is at (0,0,0) */
            0.0, 1.0, 0.);   /* up is in positive Y direction */



  /* glTranslatef(0.0, 0.0, -1.0); */

/*
  glRotatef(60, 1.0, 0.0, 0.0);
  glRotatef(-20, 0.0, 0.0, 1.0);
*/

 glShadeModel(GL_SMOOTH);
 /* glShadeModel(GL_FLAT); */

 glEnable(GL_AUTO_NORMAL);
 glEnable(GL_NORMALIZE);

}


int main(int argc, char **argv)
{
 glutInit(&argc, argv);
 glutInitDisplayMode(GLUT_DOUBLE | GLUT_RGB | GLUT_DEPTH);
 glutCreateWindow("test");
 glutDisplayFunc(display);
 init();
 glutMainLoop();
 return 0;
}
