/*
image
*/


#ifndef _YR_IMAGE_H_
#define _YR_IMAGE_H_


#include "vector.h"
#include "color.h"
#include "tga.h"



/* an image in a medium-level representation, higher than the actual
input/output format, lower than most other things.  Has a width and 
height in pixels, and color data structures for each pixel.*/
typedef struct image_s
    {
     int width, height;
     color_s **data;
    } image_s;
typedef struct image_s *image;


image image_new(int width, int height, int colortype);
void image_free(image i);
void image_write_tga(image i, char *filename);



#endif
