/*
Intersection structure stuff
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <time.h>

#include "vector.h"
#include "object.h"
#include "ints.h"




inline void ints_setbit(ints_p i, long bits)
{
 i->bits ^= bits;
}

inline long ints_getbit(ints_p i, long bits)
{
 return i->bits & bits;
}

inline long ints_testbit(ints_p i, long bits)
{
 return ((i->bits & bits) == bits);
}


inline void ints_get_target(ints_p i)
{
 obj_get_target(i->target, i->data, &(i->incray), i->dist);
 ints_setbit(i, INTS_TARGET);
}

inline void ints_get_normal(ints_p i)
{
 if(!ints_testbit(i, INTS_TARGET))
    ints_get_target(i);
 obj_get_normal(i->normal, i->data, i->target);
 ints_setbit(i, INTS_NORMAL);
}



