/*
Vertex stuff
*/

#ifndef _YR_VERTEX_H_
#define _YR_VERTEX_H_


#define VERTEX_PROP_NORMAL    0x01
#define VERTEX_PROP_TEXCOORDS 0x02
#define VERTEX_PROP_SURFACE   0x04


/* a vertex is a point and some properties */
typedef struct vertex_s
    {
     vector point;
     int props;
     vector normal;
    } vertex_s;
typedef struct vertex_s *vertex;



vertex vertex_new();
inline void vertex_mark_normal(vertex v);
inline void vertex_set_normal(vertex v, vector n);



#endif
