/*
The world!
*/

#ifndef _YR_WORLD_H_
#define _YR_WORLD_H_


#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <time.h>

#include "vector.h"
#include "surface.h"
#include "object.h"
#include "bvol.h"




/* entire scene */
typedef struct world_s
    {
     int numobjs;
     int allocobjs;
     obj *objs;
     bvol_p *bvs;
     bvol_p tree;
    } world_s;
typedef struct world_s *world;


void world_init(world w);
void world_add_obj(world w, obj o);
obj world_ints_first(world w, vector d, vectype *zm, ray_p r);


#endif
