/*
Sphere object
*/


#ifndef _YR_SPHERE_H_
#define _YR_SPHERE_H_



#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <time.h>

#include "vector.h"
#include "surface.h"
#include "object.h"
#include "bvol.h"




/* spheres are simple yet make your output impressively shiny */
typedef struct obj_sphere_s
    {
     vector point;
     vectype radius;
    } obj_sphere_s;
typedef struct obj_sphere_s *obj_sphere;


obj_sphere obj_sphere_new();
obj_sphere obj_sphere_set_basic(obj_sphere o, vector p, vectype r);
obj_sphere obj_sphere_new_set_basic(vector p, vectype r);
inline vectype test_sphere(vector target, obj_sphere sphere, ray_p ray);
inline void obj_sphere_bbox(bbox_p a, obj_sphere s);


#endif
