/*
Test object generators
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <time.h>

#include "vector.h"



void test_sphereflake(world w, vector center, int parentdir, vectype radius, int level);
void test_cubesphere_sub(vector p1, vector p2, vector p3, vector p4, int l, vector hint);
void test_cubesphere();
void test_trisphere_sub(vector p1, vector p2, vector p3, int l);
void test_trisphere();
void test_trisphere2_sub(vector p1, vector p2, vector p3, int l);
void test_trisphere2();
void test_trisphere3();

void full_spectrum(vectype c, int *r, int *g, int *b);
void test_random_discs(world w, int n);
void test_random_spheres(world w, int n, int s);
void test_random_triangles(world w, int n, int s);
void test_twodiscs(world w);


