
#ifndef _YR_TGA_H_
#define _YR_TGA_H_


/* 
data format: BGR, each row continuous, rows stored in reverse
order.  why?  because that's how GIMP saves them, and any other
way I'd need to re-arange the data.
*/

typedef struct tga_image
    {
     int width;
     int height;
     unsigned char *data;
    } tga_image;



inline unsigned char tga_getpixel(tga_image *t, int x, int y, int c);
inline unsigned char tga_setpixel(tga_image *t, int x, int y, int c, unsigned char v);
tga_image *tga_read(char *fn);
void tga_write(tga_image *t, char *fn);
tga_image *tga_new(int width, int height);

#endif
